<script lang="ts">
import Vue from 'vue';
import { Accordion } from '~/components/solutions/index.vue';

export default Vue.extend({
  name: 'DibAccordions',
  components: { Accordion },
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
  },
  data() {
    return {
      isOpenIndex: 0 as any,
    };
  },
  methods: {
    toggleController(index: number) {
      if (this.isOpenIndex === index) {
        this.isOpenIndex = null;
        return;
      }
      this.isOpenIndex = index;
    },
  },
});
</script>

<template>
  <section class="accordions-section slp-py-48 slp-py-md-96">
    <SlpContainer>
      <SlpRow class="accordions-section__row">
        <SlpColumn :cols="data.is_full_width ? 12 : 6" class="slp-pr-md-32">
          <div>
            <SlpTypography tag="h2" variant="heading2-bold" class="slp-mb-32">
              <span
                :data-aos="data.header_animation"
                :data-aos-duration="data.header_duration"
                >{{ data.title }}</span
              >
            </SlpTypography>
            <SlpTypography variant="heading5" class="slp-mb-16">
              <span
                :data-aos="data.header_animation"
                :data-aos-duration="data.header_duration"
                >{{ data.subtitle }}</span
              >
            </SlpTypography>
          </div>
        </SlpColumn>
        <SlpColumn
          :cols="data.is_full_width ? 12 : 6"
          class="accordions-column"
        >
          <div
            :data-aos="data.right_block_animation"
            :data-aos-duration="data.right_block_duration"
          >
            <SlpTypography variant="heading4-bold" tag="h3" class="slp-mb-24">
              {{ data.accordion_block.header }}
            </SlpTypography>
            <div class="accordions-section__items-wrapper">
              <Accordion
                v-for="(item, index) in data.accordion_block.items"
                :key="item.header"
                :data="item"
                :is-open="isOpenIndex == index"
                @toggleController="toggleController(index)"
              />
            </div>
          </div>
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.accordions-section {
  position: relative;

  @media (min-width: $breakpoint-lg) and (max-width: $breakpoint-xl) {
    padding: 96px 24px;
  }
  .main-cta {
    margin: $spacing-24 0 $spacing-32;
  }

  .accordions-column {
    padding-left: 32px;

    @media (max-width: $breakpoint-lg) {
      padding-left: 0;
    }
  }

  .cta {
    padding-left: $spacing-48;
    margin-top: 28px;
    text-align: left;
  }
  &__row {
    width: 100%;
    word-wrap: break-word;

    @media (max-width: $breakpoint-md) {
      gap: 48px;
    }
  }

  &__container {
    position: relative;
    @media (max-width: $breakpoint-lg) {
      margin-bottom: $spacing-48;
    }
  }

  &__items-wrapper {
    width: 100%;

    @media (max-width: 1169px) {
      max-width: 100%;
    }
    & > :last-child {
      margin-bottom: 0;
    }
  }

  &__icon {
    margin-right: $spacing-default;
    margin-bottom: 20px;
  }

  &__description {
    padding-left: $spacing-48;
  }

  &__header {
    display: flex;
    align-items: center;
    font-weight: $font-weight-bold;
    margin-bottom: $spacing-4;
  }

  &__items-w-border {
    border-bottom: 1px solid $color-surface-200;
  }
}
.offset {
  @media (max-width: $breakpoint-lg) {
    display: none;
  }
}
</style>
